opal/class/opal_object.h File Reference.TH "opal/class/opal_object.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/class/opal_object.h \- A simple C-language object-oriented system with single inheritance and ownership-based memory management using a retain/release model. 
.SH SYNOPSIS
.br
.PP
\fC#include <assert.h>\fP
.br
\fC#include <stdlib.h>\fP
.br
\fC#include 'include/sys/atomic.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBBEGIN_C_DECLS\fP"
.br
.ti -1c
.RI "#define \fBEND_C_DECLS\fP"
.br
.ti -1c
.RI "#define \fBOBJ_CLASS\fP(NAME)   (&(NAME ## _class))"
.br
.RI "\fIReturn a pointer to the class descriptor associated with a class type. \fP"
.ti -1c
.RI "#define \fBOBJ_CLASS_INSTANCE\fP(NAME, PARENT, CONSTRUCTOR, DESTRUCTOR)"
.br
.RI "\fIStatic initializer for a class descriptor. \fP"
.ti -1c
.RI "#define \fBOBJ_CLASS_DECLARATION\fP(NAME)   extern \fBopal_class_t\fP NAME ## _class"
.br
.RI "\fIDeclaration for class descriptor. \fP"
.ti -1c
.RI "#define \fBOBJ_NEW\fP(type)   ((type *) opal_obj_new(sizeof(type), OBJ_CLASS(type)))"
.br
.ti -1c
.RI "#define \fBOBJ_RETAIN\fP(object)"
.br
.RI "\fIRetain an object (by incrementing its reference count). \fP"
.ti -1c
.RI "#define \fBOBJ_REMEMBER_FILE_AND_LINENO\fP(OBJECT, FILE, LINENO)"
.br
.RI "\fIHelper macro for the debug mode to store the locations where the status of an object change. \fP"
.ti -1c
.RI "#define \fBOBJ_RELEASE\fP(object)"
.br
.RI "\fIRelease an object (by decrementing its reference count). \fP"
.ti -1c
.RI "#define \fBOBJ_CONSTRUCT\fP(object, type)"
.br
.RI "\fIConstruct (initialize) objects that are not dynamically allocated. \fP"
.ti -1c
.RI "#define \fBOBJ_CONSTRUCT_INTERNAL\fP(object, type)"
.br
.ti -1c
.RI "#define \fBOBJ_DESTRUCT\fP(object)"
.br
.RI "\fIDestruct (finalize) an object that is not dynamically allocated. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBopal_object_t\fP \fBopal_object_t\fP"
.br
.ti -1c
.RI "typedef \fBopal_class_t\fP \fBopal_class_t\fP"
.br
.ti -1c
.RI "typedef void(* \fBopal_construct_t\fP )(\fBopal_object_t\fP *)"
.br
.ti -1c
.RI "typedef void(* \fBopal_destruct_t\fP )(\fBopal_object_t\fP *)"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "static \fBopal_object_t\fP * \fBopal_obj_new\fP (size_t size, \fBopal_class_t\fP *cls)"
.br
.RI "\fICreate an object: dynamically allocate storage and run the class constructor. \fP"
.ti -1c
.RI "BEGIN_C_DECLS OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBopal_object_t\fP)"
.br
.ti -1c
.RI "OMPI_DECLSPEC void \fBopal_class_initialize\fP (\fBopal_class_t\fP *)"
.br
.RI "\fILazy initialization of class descriptor. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_class_finalize\fP (void)"
.br
.RI "\fIShut down the class system and release all memory. \fP"
.ti -1c
.RI "static END_C_DECLS void \fBopal_obj_run_constructors\fP (\fBopal_object_t\fP *object)"
.br
.RI "\fIRun the hierarchy of class constructors for this object, in a parent-first order. \fP"
.ti -1c
.RI "static void \fBopal_obj_run_destructors\fP (\fBopal_object_t\fP *object)"
.br
.RI "\fIRun the hierarchy of class destructors for this object, in a parent-last order. \fP"
.ti -1c
.RI "static int \fBopal_obj_update\fP (\fBopal_object_t\fP *object, int inc)"
.br
.RI "\fIAtomically update the object's reference count by some increment. \fP"
.in -1c
.SH "Detailed Description"
.PP 
A simple C-language object-oriented system with single inheritance and ownership-based memory management using a retain/release model. 

A class consists of a struct and singly-instantiated class descriptor. The first element of the struct must be the parent class's struct. The class descriptor must be given a well-known name based upon the class struct name (if the struct is sally_t, the class descriptor should be sally_t_class) and must be statically initialized as discussed below.
.PP
(a) To define a class
.PP
In a interface (.h) file, define the class. The first element should always be the parent class, for example 
.PP
.nf
   typedef struct sally_t sally_t;
   struct sally_t
   {
     parent_t parent;
     void *first_member;
     ...
   };

   OBJ_CLASS_DECLARATION(sally_t);

.fi
.PP
 All classes must have a parent which is also class.
.PP
In an implementation (.c) file, instantiate a class descriptor for the class like this: 
.PP
.nf
   OBJ_CLASS_INSTANCE(sally_t, parent_t, sally_construct, sally_destruct);

.fi
.PP
 This macro actually expands to 
.PP
.nf
   opal_class_t sally_t_class = {
     'sally_t',
     OBJ_CLASS(parent_t),  // pointer to parent_t_class
     sally_construct,
     sally_destruct,
     0, 0, NULL, NULL
   };

.fi
.PP
 This variable should be declared in the interface (.h) file using the OBJ_CLASS_DECLARATION macro as shown above.
.PP
sally_construct, and sally_destruct are function pointers to the constructor and destructor for the class and are best defined as static functions in the implementation file. NULL pointers maybe supplied instead.
.PP
Other class methods may be added to the struct.
.PP
(b) Class instantiation: dynamic
.PP
To create a instance of a class (an object) use OBJ_NEW: 
.PP
.nf
   sally_t *sally = OBJ_NEW(sally_t);

.fi
.PP
 which allocates memory of sizeof(sally_t) and runs the class's constructors.
.PP
Use OBJ_RETAIN, OBJ_RELEASE to do reference-count-based memory management: 
.PP
.nf
   OBJ_RETAIN(sally);
   OBJ_RELEASE(sally);
   OBJ_RELEASE(sally);

.fi
.PP
 When the reference count reaches zero, the class's destructor, and those of its parents, are run and the memory is freed.
.PP
N.B. There is no explicit free/delete method for dynamic objects in this model.
.PP
(c) Class instantiation: static
.PP
For an object with static (or stack) allocation, it is only necessary to initialize the memory, which is done using OBJ_CONSTRUCT: 
.PP
.nf
   sally_t sally;

   OBJ_CONSTRUCT(&sally, sally_t);

.fi
.PP
 The retain/release model is not necessary here, but before the object goes out of scope, OBJ_DESTRUCT should be run to release initialized resources: 
.PP
.nf
   OBJ_DESTRUCT(&sally);

.fi
.PP

.SH "Define Documentation"
.PP 
.SS "#define OBJ_CLASS(NAME)   (&(NAME ## _class))"
.PP
Return a pointer to the class descriptor associated with a class type. 
.PP
\fBParameters:\fP
.RS 4
\fINAME\fP Name of class 
.RE
.PP
\fBReturns:\fP
.RS 4
Pointer to class descriptor 
.RE
.PP

.SS "#define OBJ_CLASS_DECLARATION(NAME)   extern \fBopal_class_t\fP NAME ## _class"
.PP
Declaration for class descriptor. 
.PP
\fBParameters:\fP
.RS 4
\fINAME\fP Name of class
.RE
.PP
Put this in NAME.h 
.SS "#define OBJ_CLASS_INSTANCE(NAME, PARENT, CONSTRUCTOR, DESTRUCTOR)"
.PP
\fBValue:\fP
.PP
.nf
opal_class_t NAME ## _class = {                                     \
        # NAME,                                                         \
        OBJ_CLASS(PARENT),                                              \
        (opal_construct_t) CONSTRUCTOR,                                 \
        (opal_destruct_t) DESTRUCTOR,                                   \
        0, 0, NULL, NULL                                                \
    }
.fi
Static initializer for a class descriptor. 
.PP
\fBParameters:\fP
.RS 4
\fINAME\fP Name of class 
.br
\fIPARENT\fP Name of parent class 
.br
\fICONSTRUCTOR\fP Pointer to constructor 
.br
\fIDESTRUCTOR\fP Pointer to destructor
.RE
.PP
Put this in NAME.c 
.SS "#define OBJ_CONSTRUCT(object, type)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                            \
    OBJ_CONSTRUCT_INTERNAL((object), OBJ_CLASS(type));          \
    OBJ_REMEMBER_FILE_AND_LINENO( object, __FILE__, __LINE__ ); \
} while (0)
.fi
Construct (initialize) objects that are not dynamically allocated. 
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP Pointer to the object 
.br
\fItype\fP The object type 
.RE
.PP

.SS "#define OBJ_CONSTRUCT_INTERNAL(object, type)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                \
        if (0 == (type)->cls_initialized) {                             \
            opal_class_initialize((type));                              \
        }                                                               \
        if (NULL != object) {                                           \
            ((opal_object_t *) (object))->obj_class = (type);           \
            ((opal_object_t *) (object))->obj_reference_count = 1;      \
            opal_obj_run_constructors((opal_object_t *) (object));      \
        }                                                               \
    } while (0)
.fi
.SS "#define OBJ_DESTRUCT(object)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                \
        if (NULL != object) {                                           \
            opal_obj_run_destructors((opal_object_t *) (object));       \
            OBJ_REMEMBER_FILE_AND_LINENO( object, __FILE__, __LINE__ ); \
        }                                                               \
    } while (0)
.fi
Destruct (finalize) an object that is not dynamically allocated. 
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP Pointer to the object 
.RE
.PP

.SS "#define OBJ_RELEASE(object)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                \
        assert(NULL != object);                                         \
        assert(NULL != ((opal_object_t *) (object))->obj_class);        \
        if (0 == opal_obj_update((opal_object_t *) (object), -1)) {     \
            opal_obj_run_destructors((opal_object_t *) (object));       \
            OBJ_REMEMBER_FILE_AND_LINENO( object, __FILE__, __LINE__ ); \
            free(object);                                               \
            object = NULL;                                              \
        }                                                               \
    } while (0)
.fi
Release an object (by decrementing its reference count). 
.PP
If the reference count reaches zero, destruct (finalize) the object and free its storage.
.PP
Note: If the object is freed, then the value of the pointer is set to NULL.
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP Pointer to the object 
.RE
.PP

.SS "#define OBJ_RETAIN(object)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                \
        assert(NULL != object);                                         \
        assert(NULL != ((opal_object_t *) (object))->obj_class);        \
        if (NULL != object) {                                           \
            opal_obj_update((opal_object_t *) (object), 1);             \
        }                                                               \
        assert(((opal_object_t *) (object))->obj_reference_count >= 0); \
    } while (0)
.fi
Retain an object (by incrementing its reference count). 
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP Pointer to the object 
.RE
.PP

.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int opal_class_finalize (void)"
.PP
Shut down the class system and release all memory. 
.PP
This function should be invoked as the ABSOLUTE LAST function to use the class subsystem. It frees all associated memory with ALL classes, rendering all of them inoperable. It is here so that tools like valgrind and purify don't report still-reachable memory upon process termination. 
.SS "OMPI_DECLSPEC void opal_class_initialize (\fBopal_class_t\fP *)"
.PP
Lazy initialization of class descriptor. 
.PP
Specifically cache arrays of function pointers for the constructor and destructor hierarchies for this class.
.PP
\fBParameters:\fP
.RS 4
\fIclass\fP Pointer to class descriptor 
.RE
.PP

.SS "static \fBopal_object_t\fP * opal_obj_new (size_t size, \fBopal_class_t\fP * cls)\fC [inline, static]\fP"
.PP
Create an object: dynamically allocate storage and run the class constructor. 
.PP
Do not use this function directly: use OBJ_NEW() instead.
.PP
\fBParameters:\fP
.RS 4
\fIsize\fP Size of the object 
.br
\fIcls\fP Pointer to the class descriptor of this object 
.RE
.PP
\fBReturns:\fP
.RS 4
Pointer to the object 
.RE
.PP

.SS "static END_C_DECLS void opal_obj_run_constructors (\fBopal_object_t\fP * object)\fC [inline, static]\fP"
.PP
Run the hierarchy of class constructors for this object, in a parent-first order. 
.PP
Do not use this function directly: use \fBOBJ_CONSTRUCT()\fP instead.
.PP
WARNING: This implementation relies on a hardwired maximum depth of the inheritance tree!!!
.PP
Hardwired for fairly shallow inheritance trees 
.PP
\fBParameters:\fP
.RS 4
\fIsize\fP Pointer to the object. 
.RE
.PP

.SS "static void opal_obj_run_destructors (\fBopal_object_t\fP * object)\fC [inline, static]\fP"
.PP
Run the hierarchy of class destructors for this object, in a parent-last order. 
.PP
Do not use this function directly: use \fBOBJ_DESTRUCT()\fP instead.
.PP
\fBParameters:\fP
.RS 4
\fIsize\fP Pointer to the object. 
.RE
.PP

.SS "static int opal_obj_update (\fBopal_object_t\fP * object, int inc)\fC [inline, static]\fP"
.PP
Atomically update the object's reference count by some increment. 
.PP
This function should not be used directly: it is called via the macros OBJ_RETAIN and OBJ_RELEASE
.PP
\fBParameters:\fP
.RS 4
\fIobject\fP Pointer to the object 
.br
\fIinc\fP Increment by which to update reference count 
.RE
.PP
\fBReturns:\fP
.RS 4
New value of the reference count 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
